/**********************************************************************

	--- Qt Architect generated file ---

	File: kcrypt.cpp
	Last generated: Sat Jul 1 17:55:08 2000

 *********************************************************************/

#include <winscard.h>
#include <string.h>
#include <qfiledialog.h>
#include "kcryptfile.h"
#include "kdecryptfile.h"
#include "kcrypt.h"

#define Inherited kcryptData

kcrypt::kcrypt
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
	setCaption( "MUSCLE Smartcard File Utility" );
}


kcrypt::~kcrypt()
{
}

void kcrypt::establish() {

  LONG rv;
  LPSTR mszReaders, mszGroups;
  DWORD dwReaders, dwProtocol;
  char conerr[500];

  /* Must connect to the resource manager */

  rv = SCardEstablishContext( SCARD_SCOPE_SYSTEM, 0, 0, &hContext );

  if ( rv != SCARD_S_SUCCESS ) {
    set_status_text("Couldn't connect to pc/sc. errno: ", rv);
  } else {

    dwReaders = 0;
    mszGroups = 0;
    rv = SCardListReaders( hContext, mszGroups, 0, &dwReaders );
    if ( rv != SCARD_S_SUCCESS ) {
      set_status_text("Couldn't list readers errno: ", rv);
    } else {
      mszReaders = (char *)malloc(sizeof(char)*dwReaders);
      rv = SCardListReaders( hContext, mszGroups, mszReaders, &dwReaders );
  
      if ( rv != SCARD_S_SUCCESS ) {
	set_status_text("Couldn't list readers errno: ", rv);
      } else {
	rv = SCardConnect( hContext,  mszReaders, SCARD_SHARE_EXCLUSIVE,
			   SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1, &hCard, 
			   &dwProtocol );

	if ( rv != SCARD_S_SUCCESS ) {
	  sprintf(conerr, "%s%s", "Couldn't connect to: ", mszReaders );
	  set_status_text(conerr, rv);
	} else {
	  sprintf(conerr, "%s%s", "Connected to: ", mszReaders );
	  set_status_text(conerr, 0);
	}
      }
      
    }
  }

  show();
}


void kcrypt::set_status_text( char *mesg, unsigned long err ) {

  char errmsg[500];
  
  if ( err != 0 ) {
    sprintf(errmsg, "%s 0x%08x", mesg, err);
    label_status->setText( errmsg );
  } else {
    label_status->setText( mesg );
  }
}

void kcrypt::pbutton_quit_push() {
  SCardReleaseContext(hContext);
  exit(0);
}

void kcrypt::pbutton_decrypt_push() {

  char *tmp, *filename;
  char decfilename[500];
  int pid;

  pid = 0;

  filename = 0; tmp = 0;

  tmp = QFileDialog::getOpenFileName(".", "*.mus");

  if ( tmp ) {
    filename = strdup(tmp);

    label_status->clear();
    label_status->setText("Please wait ...");

    strcpy(decfilename, filename);
    decfilename[strlen(filename)-4] = 0;
    KDecryptFile( hCard, filename, decfilename );   
    
    label_status->clear();
    set_status_text( "File decrypted successfully", 0);
  }

  if ( filename ) free(filename);
}

void kcrypt::pbutton_encrypt_push() {

  char *tmp, *filename;
  char cptfilename[500];

  filename = 0; tmp = 0;

  tmp = QFileDialog::getOpenFileName(".", "*");

  if ( tmp ) {
    filename = strdup(tmp);
    sprintf(cptfilename, "%s%s", filename, ".mus");
    KCryptFile( filename, cptfilename );
    set_status_text( "File encrypted successfully", 0);
  }
    
  if ( filename ) free(filename);
}

